unit Delta.FMX.Objects;

interface

uses System.Classes, System.SysUtils, System.Types, System.UITypes,
  System.TypInfo, System.rtti, FMX.Graphics, FMX.Controls, FMX.Objects;

type
  TPaintEventCallBack = procedure(SenderRef, CanvasRef: Integer;
    DReference, DFuncPointer: Integer); stdcall;

procedure registerPaintEvent(Reference: Integer; AName: PAnsiChar;
  DReference, DFuncPointer: Integer; CallBack: TPaintEventCallBack); stdcall;

type
  TPaintEventWrapper = class(TComponent)
  private
    FCallBack: TPaintEventCallBack;
    FDReference: Integer;
    FDFuncPointer: Integer;
  public
    constructor Create(Owner: TComponent; DReference, DFuncPointer: Integer;
      CallBack: TPaintEventCallBack); reintroduce;
  published
    procedure Event(Sender: TObject; Canvas: TCanvas);
  end;

exports registerPaintEvent;

implementation

uses Delta.Properties;

procedure registerPaintEvent(Reference: Integer; AName: PAnsiChar;
  DReference, DFuncPointer: Integer; CallBack: TPaintEventCallBack); stdcall;
var
  nEvent: TPaintEvent;
  component: TComponent;
begin
  if Assigned(CallBack) then
  begin
    try
      component := TComponent(Reference);
      nEvent := TPaintEventWrapper.Create(component, DReference, DFuncPointer,
        CallBack).Event;
      setPropertyValue(Reference, string(AName),
        TValue.From<TPaintEvent>(nEvent));
    except
    end;
  end
  else
  begin
    setPropertyValue(Reference, string(AName), nil);
  end;
end;

{ TPaintEventWrapper }

constructor TPaintEventWrapper.Create(Owner: TComponent;
  DReference, DFuncPointer: Integer; CallBack: TPaintEventCallBack);
begin
  inherited Create(Owner);
  FCallBack := CallBack;
  FDReference := DReference;
  FDFuncPointer := DFuncPointer;
end;

procedure TPaintEventWrapper.Event(Sender: TObject; Canvas: TCanvas);
begin
  FCallBack(Integer(Sender), Integer(Canvas), FDReference, FDFuncPointer);
end;

end.
