module FMX.Controls;

import delta.core;
import delta.fmx.events;
import FMX.Types: TFmxObject;

import FMX.Graphics: TTextSettings, TCanvas;
static import FMX.Graphics;

import System.Classes, System.Types, FMX.Types;

alias TOnPaintEvent = void delegate(TObject Sender, TCanvas Canvas, TRectF ARect);

class TStyledControl: TControl
{
	this(int reference)
	{
		super(reference);
	}
}

class TTextControl: TStyledControl
{
	mixin(GenStringProperty!("Text"));
	mixin(GenBoolProperty!("WordWrap"));
	mixin(GenObjectProperty!("TextSettings", TTextSettings));
	mixin(GenSetProperty!("StyledSettings", TStyledSetting));
	
	this(int reference)
	{
		super(reference);
	}
}
	
class TControl: TFmxObject
{
	mixin(GenEnumProperty!("Align", TAlignLayout));
	mixin(GenObjectProperty!("Canvas", TCanvas));
	mixin(GenBoolProperty!("Enabled"));
	mixin(GenFloatProperty!("Height"));
	mixin(GenStringProperty!("Hint"));
	mixin(GenObjectProperty!("Margins", TBounds));
    mixin(GenObjectProperty!("Position", TPosition));
    mixin(GenShortProperty!("TabOrder")); // not 100% OK: type TTabOrder = -1..32767;
	mixin(GenBoolProperty!("TabStop"));
	mixin(GenBoolProperty!("Visible"));
	mixin(GenFloatProperty!("Width"));
	
	mixin(GenNotifyEvent!"OnClick");
	mixin(GenNotifyEvent!"OnDblClick");
    mixin(GenOnPaintEvent!"OnPaint");
	
	this(int reference)
	{
		super(reference);
	}

	static TControl Create(TComponent owner)
	{
		
		int ownerReference = owner is null ? nil : owner.reference;
		int reference = executeClassMethodReturnReferenceArgsReference("FMX.Controls.TControl", "Create", ownerReference);
		return new TControl(reference);
	}
}