module FMX.MultiResBitmap;

import delta.core;
import System.Classes;
import FMX.Graphics;

class TBitmapOfItem : TBitmap
{
    this(int reference)
    {
        super(reference);
    }
}

interface IMultiResBitmapObject : IBitmapObject
{
    // TCustomMultiResBitmap GetMultiResBitmap(); Not a public function
    TCustomMultiResBitmap MultiResBitmap();
}

class TCustomMultiResBitmap : TOwnedCollection
{
    mixin(GenBoolProperty!("Fixed"));
    
    this(int reference)
    {
        super(reference);
    }

}

class TFixedMultiResBitmap : TCustomMultiResBitmap
{
    mixin(GenIntegerIndexedProperty!("Items", TFixedBitmapItem));
    
    this(int reference)
    {
        super(reference);
    }

    override TFixedBitmapItem Add() 
    {
        int i = executeInstanceMethodReturnReferenceArgsNone(this.reference, "Add");
		return new TFixedBitmapItem(i);
    }
}

class TCustomBitmapItem : TCollectionItem
{
    mixin(GenObjectProperty!("Bitmap", TBitmapOfItem));
    
    this(int reference)
    {
        super(reference);
    }
}

class TFixedBitmapItem : TCustomBitmapItem
{
    this(int reference)
    {
        super(reference);
    }
}