module FMX.Objects;

import delta.core;
import delta.fmx.events;
import FMX.Controls: TControl;

static import FMX.Graphics;
static import FMX.MultiResBitmap;
import FMX.Graphics: TBrush, TCanvas, IBitmapObject, TBitmap;
import FMX.MultiResBitmap : TFixedMultiResBitmap, IMultiResBitmapObject, TCustomMultiResBitmap;

import System.Classes, System.Types, FMX.Types;

alias TPaintEvent = void delegate(TObject Sender, TCanvas Canvas);

class TPaintBox: TControl
{
	//alias OnPaint = TControl.OnPaint;
	//mixin(GenPaintEvent!"OnPaint");
	
	
	this(int reference)
	{
		super(reference);
	}

	static TPaintBox Create(TComponent owner)
	{
		int ownerReference = owner is null ? nil : owner.reference;
		int reference = executeClassMethodReturnReferenceArgsReference("FMX.Objects.TPaintBox", "Create", ownerReference);
		return new TPaintBox(reference);
	}

}

class TImage: TControl, IBitmapObject, IMultiResBitmapObject
{
	mixin(GenObjectProperty!("MultiResBitmap", TFixedMultiResBitmap));
	mixin(GenObjectProperty!("Bitmap", TBitmap));

	this(int reference)
	{
		super(reference);
	}
	
	static TImage Create(TComponent owner)
	{
		int ownerReference = owner is null ? nil : owner.reference;
		int reference = executeClassMethodReturnReferenceArgsReference("FMX.Objects.TImage", "Create", ownerReference);
		return new TImage(reference);
	}
}

class TShape: TControl
{
	mixin(GenObjectProperty!("Fill", TBrush));
	
	this(int reference)
	{
		super(reference);
	}
}

class TRectangle: TShape
{
	this(int reference)
	{
		super(reference);
	}
	
	static TRectangle Create(TComponent owner)
	{
		int ownerReference = owner is null ? nil : owner.reference;
		int reference = executeClassMethodReturnReferenceArgsReference("FMX.Objects.TRectangle", "Create", ownerReference);
		return new TRectangle(reference);
	}
}
