module FMX.StdCtrls;

import delta.core;
import FMX.Controls: TTextControl;
import FMX.Controls.Presentation;
import FMX.Types;
import System.Classes;

class TLabel: TTextControl
{
	this(int reference)
	{
		super(reference);
	}
	
	static TLabel Create(TComponent owner)
	{
		int ownerReference = owner is null ? nil : owner.reference;
		int reference = executeClassMethodReturnReferenceArgsReference("FMX.StdCtrls.TLabel", "Create", ownerReference);
		return new TLabel(reference);
	}
}


class TButton: TCustomButton
{
	this(int reference)
	{
		super(reference);
	}
	
	static TButton Create(TComponent owner)
	{
		int ownerReference = owner is null ? nil : owner.reference;
		int reference = executeClassMethodReturnReferenceArgsReference("FMX.StdCtrls.TButton", "Create", ownerReference);
		return new TButton(reference);
	}
}

class TSpeedButton: TCustomButton
{
	this(int reference)
	{
		super(reference);
	}
	
	static TSpeedButton Create(TComponent owner)
	{
		int ownerReference = owner is null ? nil : owner.reference;
		int reference = executeClassMethodReturnReferenceArgsReference("FMX.StdCtrls.TSpeedButton", "Create", ownerReference);
		return new TSpeedButton(reference);
	}
}

class TCustomButton: TTextControl
{
	mixin(GenObjectProperty!("Action", TBasicAction));
	
	this(int reference)
	{
		super(reference);
	}
	
	static TCustomButton Create(TComponent owner)
	{
		int ownerReference = owner is null ? nil : owner.reference;
		int reference = executeClassMethodReturnReferenceArgsReference("FMX.StdCtrls.TCustomButton", "Create", ownerReference);
		return new TCustomButton(reference);
	}
}

class TToolBar : TPresentedControl
{
	this(int reference)
	{
		super(reference);
	}

	static TToolBar Create(TComponent owner)
	{
		int ownerReference = owner is null ? nil : owner.reference;
		int reference = executeClassMethodReturnReferenceArgsReference("FMX.StdCtrls.TToolBar", "Create", ownerReference);
		return new TToolBar(reference);
	}

}