module delta.fmx.events;

import std.traits;

import delta.core;

template GenOnPaintEvent(string eventName)
{
	const char[] GenOnPaintEvent =
	`private TOnPaintEvent _`~eventName~`;

	@property void `~eventName~`(TOnPaintEvent value) {
		import std.utf: toUTFz;
		import core.sys.windows.windows;
		
		_`~eventName~`= value;

		auto dlg = __traits(getOverloads, this, "`~eventName~`")[1];
		
		alias extern(Windows) void function(int, int, int, int, int) OnPaintEventCallback;
		alias extern(Windows) void function(int, char*, int, int, OnPaintEventCallback) Fn;
		
		void delegate(int, int, int, int, int) dg = (int delphiRef, int canvasRef, int aRectRef, int dRef, int funcRef) {
			TOnPaintEvent onPaintEvent;
			onPaintEvent.funcptr = cast(void function(TObject, TCanvas, TRectF)) funcRef;
			onPaintEvent.ptr = cast(void*) dRef;
			try
			{
				TRectF* aRectF = cast(TRectF*) cast(void*) aRectRef;
				 onPaintEvent(cast(TObject) cast(void*) dRef, new TCanvas(canvasRef), *aRectF);
			}
			catch(Exception e)
			{
				import std.stdio;
				writeln(e.msg);
			}
		};
		
		auto pChar = toUTFz!(char*)("`~eventName~`");
		FARPROC fp = GetProcAddress(deltaLibrary.handle, "registerOnPaintEvent");
		Fn fn = cast(Fn) fp;
		fn(this.reference, pChar, cast(int) dlg.ptr, cast(int) dlg.funcptr, bindDelegate(dg));	
	}
	
	@property TOnPaintEvent `~eventName~`() {
		return _`~eventName~`;
	}`;	
}

template GenPaintEvent(string eventName)
{
	const char[] GenPaintEvent =
	`private TPaintEvent _`~eventName~`;

	@property override void `~eventName~`(TPaintEvent value) {
		import std.utf: toUTFz;
		import core.sys.windows.windows;
		
		_`~eventName~`= value;

		auto dlg = __traits(getOverloads, this, "`~eventName~`")[1];
		
		alias extern(Windows) void function(int, int, int, int) PaintEventCallback;
		alias extern(Windows) void function(int, char*, int, int, PaintEventCallback) Fn;
		
		void delegate(int, int, int, int) dg = (int delphiRef, int canvasRef, int dRef, int funcRef) {
			TPaintEvent paintEvent;
			paintEvent.funcptr = cast(void function(TObject, TCanvas)) funcRef;
			paintEvent.ptr = cast(void*) dRef;
			try
			{
				 paintEvent(cast(TObject) cast(void*) dRef, new TCanvas(canvasRef));
			}
			catch(Exception e)
			{
				import std.stdio;
				writeln(e.msg);
			}
		};
		auto pChar = toUTFz!(char*)("`~eventName~`");
		FARPROC fp = GetProcAddress(deltaLibrary.handle, "registerPaintEvent");
		Fn fn = cast(Fn) fp;
		fn(this.reference, pChar, cast(int) dlg.ptr, cast(int) dlg.funcptr, bindDelegate(dg));	
	}
	
	@property TPaintEvent `~eventName~`() {
		return _`~eventName~`;
	}`;	
}